package com.qmth.teachcloud.exchange.common.config;

import com.qmth.teachcloud.exchange.common.domain.*;
import org.springframework.boot.context.properties.ConfigurationProperties;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;

/**
 * @Description: 数据字典
 * @Param:
 * @return:
 * @Author: wangliang
 * @Date: 2020/4/10
 */
@Configuration
public class DictionaryConfig {

    /**
     * 模块前缀
     *
     * @return
     */
    @Bean
    @ConfigurationProperties(prefix = "prefix.url")
    public PrefixUrlDomain prefixUrlDomain() {
        return new PrefixUrlDomain();
    }

    /**
     * 系统配置
     *
     * @return
     */
    @Bean
    @ConfigurationProperties(prefix = "sys.config")
    public SysDomain sysDomain() {
        return new SysDomain();
    }

    @Bean
    @ConfigurationProperties(prefix = "com.qmth.fss.public", ignoreUnknownFields = false)
    public FssPublicDomain fssPublicDomain() {
        return new FssPublicDomain();
    }

    @Bean
    @ConfigurationProperties(prefix = "com.qmth.fss.private", ignoreUnknownFields = false)
    public FssPrivateDomain fssPrivateDomain() {
        return new FssPrivateDomain();
    }

    @Bean
    @ConfigurationProperties(prefix = "com.qmth.fss.localpdf", ignoreUnknownFields = false)
    public FssLocalPdfDomain fssLocalPdfDomain() {
        return new FssLocalPdfDomain();
    }

    @Bean
    @ConfigurationProperties(prefix = "com.qmth.fss.localfile", ignoreUnknownFields = false)
    public FssLocalFileDomain fssLocalFileDomain() {
        return new FssLocalFileDomain();
    }
}
