package com.qmth.xjtu.api;

import com.qmth.boot.api.annotation.Aac;
import com.qmth.boot.api.annotation.BOOL;
import com.qmth.boot.api.constant.ApiConstant;
import com.qmth.teachcloud.exchange.common.bean.params.OpenParams;
import com.qmth.teachcloud.exchange.common.contant.SystemConstant;
import com.qmth.teachcloud.exchange.common.util.JacksonUtil;
import com.qmth.teachcloud.exchange.common.util.Result;
import com.qmth.teachcloud.exchange.common.util.ServletUtil;
import io.swagger.annotations.*;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.stereotype.Controller;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.util.Objects;
import java.util.StringJoiner;

/**
 * <p>
 * 西安交通大学开放接口前端控制器
 * </p>
 *
 * @author wangliang
 * @since 2022-04-26
 */
@Api(tags = "西安交通大学开放接口Controller")
@Controller
@RequestMapping(ApiConstant.DEFAULT_URI_PREFIX + "/${prefix.url.open}")
@Validated
public class OpenApiController {
    private static final Logger log = LoggerFactory.getLogger(OpenApiController.class);

    @ApiOperation(value = "西安交通大学cas鉴权接口")
    @ApiResponses({@ApiResponse(code = 200, message = "返回消息", response = Result.class)})
    @RequestMapping(value = "/authentication", method = RequestMethod.GET)
    @Aac(auth = BOOL.FALSE)
    public String authentication(@ApiParam(value = "工号", required = true) @RequestParam String account,
                                 @ApiParam(value = "返回url") @RequestParam(required = false) String returnUrl) throws IOException {
        HttpServletRequest request = ServletUtil.getRequest();
        HttpServletResponse response = ServletUtil.getResponse();
        String schoolCode = "test-school-2";

        //todo 学校业务逻辑待完善

        StringJoiner stringJoiner = new StringJoiner("")
                .add(SystemConstant.JUMP_API_URL)
//                .add(SystemConstant.GET_UNKNOWN).add(SystemConstant.USER_COMMON).add(SystemConstant.GET_EQUAL).add(URLEncoder.encode(account, SystemConstant.CHARSET))
                .add(SystemConstant.GET_UNKNOWN).add(SystemConstant.USER_COMMON).add(SystemConstant.GET_EQUAL).add(account)
                .add(SystemConstant.GET_SYMBOL).add(SystemConstant.SCHOOL_CODE_COMMON).add(SystemConstant.GET_EQUAL).add(schoolCode);

        if (Objects.nonNull(returnUrl) && !Objects.equals(returnUrl, "")) {
            stringJoiner = stringJoiner.add(SystemConstant.GET_SYMBOL).add(SystemConstant.RETURN_URL_COMMON).add(SystemConstant.GET_EQUAL).add(returnUrl);
        }
        OpenParams openParams = new OpenParams();
        openParams.setName("test1");

        if (Objects.nonNull(openParams)) {
            stringJoiner = stringJoiner.add(SystemConstant.GET_SYMBOL).add(SystemConstant.PARAMS_COMMON).add(SystemConstant.GET_EQUAL).add(JacksonUtil.parseJson(openParams));
        }
        log.info("redirectUrl:{},account:{},schoolCode:{}", stringJoiner.toString(), account, schoolCode);
        return stringJoiner.toString();
    }
}
